/* ReSCAL - Stochastic simulation engine
 *
 * Copyright (C) 2011
 *
 * Author: Olivier Rozier <rozier@ipgp.fr>
 *
 * This file is part of ReSCAL.
 *
 * ReSCAL is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


enum TIME_UNIT {UNIT_COMP, UNIT_T0, UNIT_RT};

enum TIME_CORR {TC_MAXI, TC_CGV, TC_MINI};

enum CSP_TEMPLATES {CSP_CUSTOM, CSP_SRC_DISK_CEIL, CSP_SRC_RECT, CSP_2_SRC_DISK_CEIL};

/// List of "general" event types
/// EVT_LOG: save logs
/// EVT_SAVE_CSP: save CSP and ALTI data files
/// EVT_SAVE_HPP: save HPP and GRAD_VEL data files
/// EVT_SAVE_PNG: save PNG images
/// EVT_STOP: stop simulation
/// EVT_TIME_CORR: estimate the coefficient for time correction
/// EVT_GEN_NUMBER: number of general types of event (not an event type) - this value should be at the end of the list
enum EVT_TYPE_GEN {EVT_LOG, EVT_SAVE_CSP, EVT_SAVE_HPP, EVT_SAVE_PNG, EVT_STOP, EVT_TIME_CORR, EVT_GEN_NUMBER};

/// Names of "general" event types
#define EVT_NAME_GEN { "EVT_LOG", "EVT_SAVE_CSP", "EVT_SAVE_HPP", "EVT_SAVE_PNG", "EVT_STOP", "EVT_TIME_CORR" }

void init_simul();
void init_simul_time();
void params_simul();
int simul_csp();
void dump_time();
void dump_trans_rate();
void simul_save_auto();
void simul_general_event(int type);
